function [VariableType,F_x,F_w,F_xw,h] = robust_classify_variables_newest(F,h,ops,w);

Dependency = iterateDependance( yalmip('monomtable') | yalmip('getdependence'));
DependsOnw = find(any(full(Dependency(:,getvariables(w))),2));

h_variables = getvariables(h);
h_w = find(ismember(h_variables,DependsOnw));
if ~isempty(h_w)
    base = getbase(h);
    h0 = base(1);
    base = base(2:end);base = base(:);
    sdpvar t
    
    F = [F,base(h_w(:))'*recover(h_variables(h_w)) < t];
    base(h_w) = 0;
    h = base(:)'*recover(h_variables) + t;
    
    Dependency = iterateDependance(yalmip('monomtable') | yalmip('getdependence'));
    DependsOnw = find(any(full(Dependency(:,getvariables(w))),2));    
end

DoesNotDependOnw = find(~any(full(Dependency(:,getvariables(w))),2));
[~,x_variables] = find(Dependency(DoesNotDependOnw,:));

F_w = [];
F_x = [];
F_xw = [];
for i = 1:length(F)
    F_vars = getvariables(F(i));
    F_vars = find(any((Dependency(F_vars,:)),1));
    if all(ismember(F_vars,DependsOnw))
        F_w = F_w + F(i);
    elseif all(ismember(F_vars,DoesNotDependOnw))
       F_x = F_x + F(i);
    else
       F_xw = F_xw + F(i);
    end            
end

[F_x,failure,cause] = expandmodel(F_x,h,ops);
[F_w,failure,cause] = expandmodel(F_w,[],ops);
ops.expandbilinear = 1;
ops.reusemodel = 1; % Might be case x+norm(w)<1, norm(w)<1
[F_xw,failure,cause] = expandmodel(F_xw,h,ops,w);

w_variables = depends(F_w);
x_variables = unique([depends(F_x) depends(F_xw) depends(h)]);
x_variables = setdiff(x_variables,w_variables);

% After exanding the conic represntable, we have introduced new variables
Dependency = iterateDependance(yalmip('monomtable') | yalmip('getdependence'));

auxiliary = unique([yalmip('extvariables') yalmip('auxvariables')]);
if ~isempty(auxiliary)
    DependsOnw = find(any(full(Dependency(:,getvariables(w))),2));
    DoesNotDependOnw = find(~any(full(Dependency(:,getvariables(w))),2));
    
    temp = intersect(DependsOnw,x_variables);
    x_variables = setdiff(x_variables,DependsOnw);
    aux_with_w_dependence = temp;  
else
    aux_with_w_dependence = [];   
end
    
x = recover(x_variables);
w = recover(w_variables);

VariableType.Graph = Dependency;
VariableType.x_variables = x_variables;
VariableType.w_variables = w_variables;
VariableType.aux_with_w_dependence = aux_with_w_dependence;

function Graph = iterateDependance(Graph)

Graph = Graph + speye(length(Graph));
Graph0 = double(Graph*Graph ~=0);
while ~isequal(Graph,Graph0)
    Graph = Graph0;
    Graph0 = double(Graph*Graph~=0);  
end
